#ifndef _DATA_
#define _DATA_
typedef struct Data3DMarkers Data3DMarkers;
typedef struct Data3DModel Data3DModel;
typedef struct Shadows Shadows;
typedef struct Blur Blur;
#include "main.h"
#include "game.h"
#include "render.h"
enum {
    DataNone,
    DataUnsheath,
    DataSword,
    DataDemon,
    DataMagicMissile,
    DataBook,
    DataFireball,
    DataHeal,
    DataTroll,
    DataRat,
    DataDragon,
    DataArrow,
    DataSqueak,
    DataSpell,
    DataNo,
    DataDeath,
    DataYell,
    DataRoar,
    DataRatGone,
    DataPotion,
    DataCoin,
    DataMusic,
    DataScroll,
    DataPay,
    DataBuild,
    DataWin,
    DataTrollDie,
    DataEvil,
    DataCount
};
struct Data3DMarkers {
    Land4x4Matrix head;
    Land4x4Matrix mainhand;
    Land4x4Matrix off;
    Land4x4Matrix neck;
};
struct Data3DModel {
    int kid;
    char * name;
    LandArray * frames;
    Shadows * shadows;
    LandArray * markers /* [Data3Dmarkers] */;
    Kind * hd;
    float scale;
    float height;
    bool moving;
};
extern LandFont * font_small;
extern LandFont * font_menu;
struct Shadows {
    int submitted;
    bool needed;
    LandArray * frames;
};
struct Blur {
    Shadows * shadows;
    LandImage * image;
    int t;
    uint8_t * rgba;
};
void queue_blur(LandImage * image, Shadows * shadows);
void data_check_blur(void);
void data_status(str x);
void data_init(void);
LandImage* data_start_shadow(void);
void data_complete_shadow(LandImage * image);
LandTriangles* create_shadow_mesh(LandImage * image);
Data3DModel* add_3d_model_frames(str name, float scale, bool moving);
Data3DModel* data_get_model(str name);
void data_reload_fonts(void);
void data_play(int sid);
void data_play_vol(int sid, float vol);
void data_playq(int sid);
void data_playq_vol(int sid, float vol);
void play_queued_sounds(int qt);
#endif
