#ifndef _GAME_
#define _GAME_
typedef struct Game Game;
#include "main.h"
#include "land/obj/obj.h"
#include "dungeon.h"
#include "render.h"
#include "menu.h"
#include "test.h"
#include "names.h"
struct Game {
    int level;
    int level_unlocked;
    int level_visited;
    Dungeon * dungeon;
    Dungeon * levels [1 + 9];
    LandArray * kinds;
    LandHash * model_by_name;
    LandArray * kind_by_id;
    LandArray * objects;
    LandArray * moving;
    LandArray * particles;
    int start_t;
    uint64_t t;
    int gold;
    int used [3];
    int used_stats [3] [100];
    Kind * wall_hidden;
    Kind * ground [5];
    Kind * wall;
    Kind * wall2;
    Kind * wall3;
    Kind * wall4;
    Kind * wall5;
    Kind * wall_torch;
    Kind * vendor_head;
    Kind * vendor_potion;
    Kind * vendor_shield;
    Kind * vendor_smith;
    Kind * quest1;
    Kind * quest2;
    Kind * quest3;
    Kind * quest4;
    Kind * trap_box;
    Kind * trap_fire;
    Kind * trap_poison;
    Kind * trap_lightning;
    Kind * chest;
    Kind * knight;
    Kind * rat;
    Kind * troll;
    Kind * troll2;
    Kind * archer;
    Kind * elf;
    Kind * priest;
    Kind * mage;
    Kind * dragon;
    Kind * arrow;
    Kind * potion_hp;
    Kind * potion_mp;
    Kind * potion_res;
    Kind * fireball;
    Kind * missile;
    Kind * helmet;
    Kind * sword;
    Kind * shield;
    Kind * bow;
    Kind * quiver;
    Kind * book;
    Kind * wand;
    Kind * helmet2;
    Kind * hat;
    bool paused;
    bool speed;
    bool title;
    int selx, sely;
    int hover_x, hover_y;
    int hover_cid;
    float mx, my;
    uint64_t bill_due_t;
    int owed;
    bool show_bill;
    bool have_bill;
    bool welcome;
    bool over;
    int cheat_timeout_t;
    int cheat_pos;
    char cheat [100];
};
extern int debug_grid;
extern int debug_dungeon;
extern int debug_no_models;
extern int debug_bill;
extern int debug_no_restrict;
extern Game * game;
Game* game_global(void);
void game_new(void);
void game_reset(void);
char* kind_create_name(Kind * k);
void game_change_level(int d);
void game_music_volume(int v);
void game_init(void);
void cheat_health(void);
void cheat_equip(void);
void cheat(void);
void game_tick(void);
void particle_tick(Object * ob);
void game_draw(void);
void game_done(void);
void game_place_selected_kind(int kid);
void game_spawn_selected_monster(Kind * k);
Creature* game_spawn_hero(Dungeon * dungeon, Kind * k, bool spawn);
void game_buy(Kind * k, int x, int y);
void game_use(Kind * k, int x, int y);
void game_projectile(Kind * k, int c1, int c2);
void game_unlock_level(void);
bool game_reset_used(int uid);
void game_pay_bills(void);
int game_outstanding(void);
#endif
