#ifndef _MENU_
#define _MENU_
typedef struct MenuItem MenuItem;
typedef struct Menu Menu;
#include "common.h"
#include "data.h"
struct MenuItem {
    char * name;
    bool enabled;
    Kind * place;
};
struct Menu {
    bool shown;
    int x, y;
    int w, h;
    LandArray * items /* [MenuItem] */;
    int click_x, click_y;
    float pay_x, pay_y, pay_r;
    uint64_t start_t;
    bool title, over, bill, welcome;
};
extern Menu menu;
MenuItem* menu_item_new(str name, Kind * place, bool enabled);
void menu_item_destroy(MenuItem * self);
void menu_add_if(str item, Kind * place, bool enabled);
void menu_click(int x, int y);
void menu_clear(void);
void menu_show(int x, int y, MenuItem * item);
void menu_draw_hover_info(void);
void draw_pause_button(void);
bool menu_click_button(float mx, float my);
void menu_draw(void);
void bill_draw(void);
void welcome_draw(void);
void over_draw(void);
void title_draw(void);
#endif
